﻿using System;
using Android.Media;
using Android.Widget;
using System.Collections.Generic;
using Android.Content;

namespace LoopDroid
{
	public class LoopSound
	{
		MediaPlayer[] _sound = new MediaPlayer[7];
		Button _button;
		TextView _label;
		public List<int> _loop = new List<int>();
		int _current;

		public LoopSound(Context context,string sound,TextView label,Button button)
		{
			_label = label;
			_button = button;
			switch (sound)
			{
				case "Clap":
					_sound[0] = MediaPlayer.Create(context, Resource.Raw.Clap0);
					_sound[1] = MediaPlayer.Create(context, Resource.Raw.Clap1);
					_sound[2] = MediaPlayer.Create(context, Resource.Raw.Clap2);
					_sound[3] = MediaPlayer.Create(context, Resource.Raw.Clap3);
					_sound[4] = MediaPlayer.Create(context, Resource.Raw.Clap4);
					_sound[5] = MediaPlayer.Create(context, Resource.Raw.Clap5);
					_sound[6] = MediaPlayer.Create(context, Resource.Raw.Clap6);
					break;
				case "Electric":
					_sound[0] = MediaPlayer.Create(context, Resource.Raw.Electric0);
					_sound[1] = MediaPlayer.Create(context, Resource.Raw.Electric1);
					_sound[2] = MediaPlayer.Create(context, Resource.Raw.Electric2);
					_sound[3] = MediaPlayer.Create(context, Resource.Raw.Electric3);
					_sound[4] = MediaPlayer.Create(context, Resource.Raw.Electric4);
					_sound[5] = MediaPlayer.Create(context, Resource.Raw.Electric5);
					_sound[6] = MediaPlayer.Create(context, Resource.Raw.Electric6);
					break;
				default:
					_sound[0] = MediaPlayer.Create(context, Resource.Raw.Room0);
					_sound[1] = MediaPlayer.Create(context, Resource.Raw.Room1);
					_sound[2] = MediaPlayer.Create(context, Resource.Raw.Room2);
					_sound[3] = MediaPlayer.Create(context, Resource.Raw.Room3);
					_sound[4] = MediaPlayer.Create(context, Resource.Raw.Room4);
					_sound[5] = MediaPlayer.Create(context, Resource.Raw.Room5);
					_sound[6] = MediaPlayer.Create(context, Resource.Raw.Room6);
					break;
			}
			_button.Enabled = false;
		}

		public void Add(int index)
		{
			if (_loop.Count == 0)
			{
				_label.Text = "";
				_button.Enabled = true;
				_current = 0;
			}
			_loop.Add(index);
			_sound[index].Start();
			_label.Text += index + ",";
		}

		public void Play(int index = -1)
		{
			if (index < 0)
			{
				_button.Enabled = false;
				index = _loop[_current];
			}
			_sound[index].SeekTo(0);
			_sound[index].Start();
			_sound[index].Completion += SoundCompletion;
		}

		void SoundCompletion(object sender, EventArgs e)
		{
			var sound = sender as MediaPlayer;
			sound.Completion -= SoundCompletion;
			_current++;
			if (_current < _loop.Count)
			{
				Play(_loop[_current]);
			}
			else
			{
				_loop.Clear();
			}
		}
	}
}
