﻿using Android.App;
using Android.OS;
using Android.Views;
using Android.Widget;

namespace LoopDroid
{
	public class TabFragment : Fragment
	{
		LoopSound _sound;
		Activity _activity;
		string _soundName;

		public TabFragment(Activity activity,string sound)
		{
			_activity = activity;
			_soundName = sound;
		}

		public override View OnCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
		{
			base.OnCreateView(inflater, container, savedInstanceState);

			var view = inflater.Inflate(Resource.Layout.Tab, container, false);
			TextView title = view.FindViewById<TextView>(Resource.Id.textTitle);
			title.Text = _soundName;
			Button button = view.FindViewById<Button>(Resource.Id.playButton);
			TextView label = view.FindViewById<TextView>(Resource.Id.textLoop);
			_sound = new LoopSound(_activity, _soundName, label, button);
			button.Click += delegate { _sound.Play(); };

			Button button0 = view.FindViewById<Button>(Resource.Id.button0);
			button0.Click += delegate { _sound.Add(0); };
			Button button1 = view.FindViewById<Button>(Resource.Id.button1);
			button1.Click += delegate { _sound.Add(1); };
			Button button2 = view.FindViewById<Button>(Resource.Id.button2);
			button2.Click += delegate { _sound.Add(2); };
			Button button3 = view.FindViewById<Button>(Resource.Id.button3);
			button3.Click += delegate { _sound.Add(3); };
			Button button4 = view.FindViewById<Button>(Resource.Id.button4);
			button4.Click += delegate { _sound.Add(4); };
			Button button5 = view.FindViewById<Button>(Resource.Id.button5);
			button5.Click += delegate { _sound.Add(5); };
			Button button6 = view.FindViewById<Button>(Resource.Id.button6);
			button6.Click += delegate { _sound.Add(6); };

			return view;
		}
	}
}
